b45e13fe5c
cherry pick from qemu-kvm-ev-2.9.0-16.el7_4.11.1 https://cbs.centos.org/koji/buildinfo?buildID=21003 Tue Jun 13 2017 Miroslav Rezanina <mrezanin@redhat.com> - rhev-2.9.0-10.el7 - kvm-nbd-make-it-thread-safe-fix-qcow2-over-nbd.patch [bz#1454582] Tue Aug 15 2017 Miroslav Rezanina <mrezanin@redhat.com> - rhev-2.9.0-16.el7_4.4 - kvm-nbd-strict-nbd_wr_syncv.patch [bz#1467509] - kvm-nbd-read_sync-and-friends-return-0-on-success.patch [bz#1467509] - kvm-nbd-make-nbd_drop-public.patch [bz#1467509] - kvm-nbd-server-get-rid-of-nbd_negotiate_read-and-friends.patch [bz#1467509] Mon Oct 09 2017 Miroslav Rezanina <mrezanin@redhat.com> - rhev-2.9.0-16.el7_4.9 - kvm-nbd-client-Fix-regression-when-server-sends-garbage.patch [bz#1495474] - kvm-fix-build-failure-in-nbd_read_reply_entry.patch [bz#1495474] - kvm-nbd-client-avoid-spurious-qio_channel_yield-re-entry.patch [bz#1495474] - kvm-nbd-client-avoid-read_reply_co-entry-if-send-failed.patch [bz#1495474] - kvm-qemu-iotests-improve-nbd-fault-injector.py-startup-p.patch [bz#1495474] - kvm-qemu-iotests-test-NBD-over-UNIX-domain-sockets-in-08.patch [bz#1495474] - kvm-block-nbd-client-nbd_co_send_request-fix-return-code.patch [bz#1495474] - Resolves: bz#1495474
455 lines
12 KiB
Diff
455 lines
12 KiB
Diff
From 0000000000000000000000000000000000000000 Mon Sep 17 00:00:00 2001
|
|
From: Eric Blake <eblake@redhat.com>
|
|
Date: Wed, 27 Sep 2017 17:57:24 +0200
|
|
Subject: [PATCH] qemu-iotests: test NBD over UNIX domain sockets in 083
|
|
|
|
RH-Author: Eric Blake <eblake@redhat.com>
|
|
Message-id: <20170927175725.20023-7-eblake@redhat.com>
|
|
Patchwork-id: 76670
|
|
O-Subject: [RHEV-7.4.z qemu-kvm-rhev PATCH 6/7] qemu-iotests: test NBD over UNIX domain sockets in 083
|
|
Bugzilla: 1495474
|
|
RH-Acked-by: Max Reitz <mreitz@redhat.com>
|
|
RH-Acked-by: Jeffrey Cody <jcody@redhat.com>
|
|
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
|
From: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
|
083 only tests TCP. Some failures might be specific to UNIX domain
|
|
sockets.
|
|
|
|
A few adjustments are necessary:
|
|
|
|
1. Generating a port number and waiting for server startup is
|
|
TCP-specific. Use the new nbd-fault-injector.py startup protocol to
|
|
fetch the address. This is a little more elegant because we don't
|
|
need netstat anymore.
|
|
|
|
2. The NBD filter does not work for the UNIX domain sockets URIs we
|
|
generate and must be extended.
|
|
|
|
3. Run all tests twice: once for TCP and once for UNIX domain sockets.
|
|
|
|
Reviewed-by: Eric Blake <eblake@redhat.com>
|
|
Signed-off-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
Message-Id: <20170829122745.14309-4-stefanha@redhat.com>
|
|
Signed-off-by: Eric Blake <eblake@redhat.com>
|
|
(cherry picked from commit 02d2d860d25e439f0e88658c701668ab684568fb)
|
|
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
|
|
Conflicts:
|
|
tests/qemu-iotests/083.out - error message improvements not backported
|
|
|
|
Signed-off-by: Eric Blake <eblake@redhat.com>
|
|
---
|
|
tests/qemu-iotests/083 | 136 +++++++++++++++++++++++--------------
|
|
tests/qemu-iotests/083.out | 143 ++++++++++++++++++++++++++++++++++-----
|
|
tests/qemu-iotests/common.filter | 4 +-
|
|
3 files changed, 212 insertions(+), 71 deletions(-)
|
|
|
|
diff --git a/tests/qemu-iotests/083 b/tests/qemu-iotests/083
|
|
index bff9360..0306f11 100755
|
|
--- a/tests/qemu-iotests/083
|
|
+++ b/tests/qemu-iotests/083
|
|
@@ -27,6 +27,14 @@ echo "QA output created by $seq"
|
|
here=`pwd`
|
|
status=1 # failure is the default!
|
|
|
|
+_cleanup()
|
|
+{
|
|
+ rm -f nbd.sock
|
|
+ rm -f nbd-fault-injector.out
|
|
+ rm -f nbd-fault-injector.conf
|
|
+}
|
|
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
+
|
|
# get standard environment, filters and checks
|
|
. ./common.rc
|
|
. ./common.filter
|
|
@@ -35,81 +43,105 @@ _supported_fmt generic
|
|
_supported_proto nbd
|
|
_supported_os Linux
|
|
|
|
-# Pick a TCP port based on our pid. This way multiple instances of this test
|
|
-# can run in parallel without conflicting.
|
|
-choose_tcp_port() {
|
|
- echo $((($$ % 31744) + 1024)) # 1024 <= port < 32768
|
|
-}
|
|
-
|
|
-wait_for_tcp_port() {
|
|
- while ! (netstat --tcp --listening --numeric | \
|
|
- grep "$1.*0\\.0\\.0\\.0:\\*.*LISTEN") >/dev/null 2>&1; do
|
|
- sleep 0.1
|
|
+check_disconnect() {
|
|
+ local event export_name=foo extra_args nbd_addr nbd_url proto when
|
|
+
|
|
+ while true; do
|
|
+ case $1 in
|
|
+ --classic-negotiation)
|
|
+ shift
|
|
+ extra_args=--classic-negotiation
|
|
+ export_name=
|
|
+ ;;
|
|
+ --tcp)
|
|
+ shift
|
|
+ proto=tcp
|
|
+ ;;
|
|
+ --unix)
|
|
+ shift
|
|
+ proto=unix
|
|
+ ;;
|
|
+ *)
|
|
+ break
|
|
+ ;;
|
|
+ esac
|
|
done
|
|
-}
|
|
|
|
-check_disconnect() {
|
|
event=$1
|
|
when=$2
|
|
- negotiation=$3
|
|
echo "=== Check disconnect $when $event ==="
|
|
echo
|
|
|
|
- port=$(choose_tcp_port)
|
|
-
|
|
cat > "$TEST_DIR/nbd-fault-injector.conf" <<EOF
|
|
[inject-error]
|
|
event=$event
|
|
when=$when
|
|
EOF
|
|
|
|
- if [ "$negotiation" = "--classic-negotiation" ]; then
|
|
- extra_args=--classic-negotiation
|
|
- nbd_url="nbd:127.0.0.1:$port"
|
|
+ if [ "$proto" = "tcp" ]; then
|
|
+ nbd_addr="127.0.0.1:0"
|
|
else
|
|
- nbd_url="nbd:127.0.0.1:$port:exportname=foo"
|
|
+ nbd_addr="$TEST_DIR/nbd.sock"
|
|
+ fi
|
|
+
|
|
+ rm -f "$TEST_DIR/nbd.sock"
|
|
+
|
|
+ $PYTHON nbd-fault-injector.py $extra_args "$nbd_addr" "$TEST_DIR/nbd-fault-injector.conf" >"$TEST_DIR/nbd-fault-injector.out" 2>&1 &
|
|
+
|
|
+ # Wait for server to be ready
|
|
+ while ! grep -q 'Listening on ' "$TEST_DIR/nbd-fault-injector.out"; do
|
|
+ sleep 0.1
|
|
+ done
|
|
+
|
|
+ # Extract the final address (port number has now been assigned in tcp case)
|
|
+ nbd_addr=$(sed 's/Listening on \(.*\)$/\1/' "$TEST_DIR/nbd-fault-injector.out")
|
|
+
|
|
+ if [ "$proto" = "tcp" ]; then
|
|
+ nbd_url="nbd+tcp://$nbd_addr/$export_name"
|
|
+ else
|
|
+ nbd_url="nbd+unix:///$export_name?socket=$nbd_addr"
|
|
fi
|
|
|
|
- $PYTHON nbd-fault-injector.py $extra_args "127.0.0.1:$port" "$TEST_DIR/nbd-fault-injector.conf" >/dev/null 2>&1 &
|
|
- wait_for_tcp_port "127\\.0\\.0\\.1:$port"
|
|
$QEMU_IO -c "read 0 512" "$nbd_url" 2>&1 | _filter_qemu_io | _filter_nbd
|
|
|
|
echo
|
|
}
|
|
|
|
-for event in neg1 "export" neg2 request reply data; do
|
|
- for when in before after; do
|
|
- check_disconnect "$event" "$when"
|
|
- done
|
|
-
|
|
- # Also inject short replies from the NBD server
|
|
- case "$event" in
|
|
- neg1)
|
|
- for when in 8 16; do
|
|
- check_disconnect "$event" "$when"
|
|
- done
|
|
- ;;
|
|
- "export")
|
|
- for when in 4 12 16; do
|
|
- check_disconnect "$event" "$when"
|
|
+for proto in tcp unix; do
|
|
+ for event in neg1 "export" neg2 request reply data; do
|
|
+ for when in before after; do
|
|
+ check_disconnect "--$proto" "$event" "$when"
|
|
done
|
|
- ;;
|
|
- neg2)
|
|
- for when in 8 10; do
|
|
- check_disconnect "$event" "$when"
|
|
- done
|
|
- ;;
|
|
- reply)
|
|
- for when in 4 8; do
|
|
- check_disconnect "$event" "$when"
|
|
- done
|
|
- ;;
|
|
- esac
|
|
-done
|
|
|
|
-# Also check classic negotiation without export information
|
|
-for when in before 8 16 24 28 after; do
|
|
- check_disconnect "neg-classic" "$when" --classic-negotiation
|
|
+ # Also inject short replies from the NBD server
|
|
+ case "$event" in
|
|
+ neg1)
|
|
+ for when in 8 16; do
|
|
+ check_disconnect "--$proto" "$event" "$when"
|
|
+ done
|
|
+ ;;
|
|
+ "export")
|
|
+ for when in 4 12 16; do
|
|
+ check_disconnect "--$proto" "$event" "$when"
|
|
+ done
|
|
+ ;;
|
|
+ neg2)
|
|
+ for when in 8 10; do
|
|
+ check_disconnect "--$proto" "$event" "$when"
|
|
+ done
|
|
+ ;;
|
|
+ reply)
|
|
+ for when in 4 8; do
|
|
+ check_disconnect "--$proto" "$event" "$when"
|
|
+ done
|
|
+ ;;
|
|
+ esac
|
|
+ done
|
|
+
|
|
+ # Also check classic negotiation without export information
|
|
+ for when in before 8 16 24 28 after; do
|
|
+ check_disconnect "--$proto" --classic-negotiation "neg-classic" "$when"
|
|
+ done
|
|
done
|
|
|
|
# success, all done
|
|
diff --git a/tests/qemu-iotests/083.out b/tests/qemu-iotests/083.out
|
|
index 0c13888..7419722 100644
|
|
--- a/tests/qemu-iotests/083.out
|
|
+++ b/tests/qemu-iotests/083.out
|
|
@@ -1,43 +1,43 @@
|
|
QA output created by 083
|
|
=== Check disconnect before neg1 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect after neg1 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 8 neg1 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 16 neg1 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect before export ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect after export ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 4 export ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 12 export ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 16 export ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect before neg2 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect after neg2 ===
|
|
|
|
@@ -45,11 +45,11 @@ read failed: Input/output error
|
|
|
|
=== Check disconnect 8 neg2 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect 10 neg2 ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT:exportname=foo
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/foo
|
|
|
|
=== Check disconnect before request ===
|
|
|
|
@@ -86,23 +86,132 @@ read 512/512 bytes at offset 0
|
|
|
|
=== Check disconnect before neg-classic ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/
|
|
|
|
=== Check disconnect 8 neg-classic ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/
|
|
|
|
=== Check disconnect 16 neg-classic ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/
|
|
|
|
=== Check disconnect 24 neg-classic ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/
|
|
|
|
=== Check disconnect 28 neg-classic ===
|
|
|
|
-can't open device nbd:127.0.0.1:PORT
|
|
+can't open device nbd+tcp://127.0.0.1:PORT/
|
|
+
|
|
+=== Check disconnect after neg-classic ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect before neg1 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect after neg1 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 8 neg1 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 16 neg1 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect before export ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect after export ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 4 export ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 12 export ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 16 export ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect before neg2 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect after neg2 ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect 8 neg2 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 10 neg2 ===
|
|
+
|
|
+can't open device nbd+unix:///foo?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect before request ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect after request ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect before reply ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect after reply ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect 4 reply ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect 8 reply ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect before data ===
|
|
+
|
|
+read failed: Input/output error
|
|
+
|
|
+=== Check disconnect after data ===
|
|
+
|
|
+read 512/512 bytes at offset 0
|
|
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
+
|
|
+=== Check disconnect before neg-classic ===
|
|
+
|
|
+can't open device nbd+unix:///?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 8 neg-classic ===
|
|
+
|
|
+can't open device nbd+unix:///?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 16 neg-classic ===
|
|
+
|
|
+can't open device nbd+unix:///?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 24 neg-classic ===
|
|
+
|
|
+can't open device nbd+unix:///?socket=TEST_DIR/nbd.sock
|
|
+
|
|
+=== Check disconnect 28 neg-classic ===
|
|
+
|
|
+can't open device nbd+unix:///?socket=TEST_DIR/nbd.sock
|
|
|
|
=== Check disconnect after neg-classic ===
|
|
|
|
diff --git a/tests/qemu-iotests/common.filter b/tests/qemu-iotests/common.filter
|
|
index c9a2d5c..f06d4dc 100644
|
|
--- a/tests/qemu-iotests/common.filter
|
|
+++ b/tests/qemu-iotests/common.filter
|
|
@@ -154,9 +154,9 @@ _filter_nbd()
|
|
#
|
|
# Filter out the TCP port number since this changes between runs.
|
|
sed -e '/nbd\/.*\.c:/d' \
|
|
- -e 's#nbd:\(//\)\?127\.0\.0\.1:[0-9]*#nbd:\1127.0.0.1:PORT#g' \
|
|
+ -e 's#127\.0\.0\.1:[0-9]*#127.0.0.1:PORT#g' \
|
|
-e "s#?socket=$TEST_DIR#?socket=TEST_DIR#g" \
|
|
- -e 's#\(exportname=foo\|PORT\): Failed to .*$#\1#'
|
|
+ -e 's#\(foo\|PORT/\?\|.sock\): Failed to .*$#\1#'
|
|
}
|
|
|
|
# make sure this script returns success
|
|
--
|
|
1.8.3.1
|
|
|